Lattice Grid Buy a licence

demo D180

Profiling a column

Count, spread, quartiles and outliers from the API, into a panel of your own

grid.statistics.profile(col)

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">
<style>
  #grid > div { height: 460px; }
  #out { margin-top: 12px; }
</style>
<div id="app"></div>

<script type="module">
  import * as Vue from 'https://esm.sh/vue@3';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/vue.esm.min.js';

  const LatticeGrid = createLatticeGrid({ vue: Vue, createGrid });

  Vue.createApp({
    components: { LatticeGrid },
    data() {
      return {
        config: {
          rowKey: 'id',
          toolPanel: { side: 'left', panels: ['filters', 'columns'] },
          columns: [
            { field: 'symbol', title: 'Symbol', layout: { pin: 'start', width: 120 } },
            { field: 'desk', title: 'Desk', filter: { type: 'set' } },
            { field: 'price', title: 'Price', type: 'number' },
            { field: 'bid', title: 'Bid', type: 'number' },
            { field: 'volume', title: 'Volume', type: 'number' },
            { field: 'notional', title: 'Notional', type: 'number',
              format: { style: 'currency', currency: 'USD' }, total: 'sum' },
          ],
          rows,  // trade records, one per row
        },
      };
    },
    mounted() {
      // Recompute once the grid is live, then on every filter change.
      this.report();
    },
    methods: {
      // profile summarises one column over the filtered rows into a single object
      // you can read straight into a panel of your own.
      report() {
        const grid = this.$refs.grid.grid();
        document.getElementById('out').textContent =
          JSON.stringify(grid.statistics.profile('notional'), null, 2);
      },
    },
    template: `
      <div id="grid"><lattice-grid ref="grid" v-bind="config" @filter-changed="report" /></div>
      <pre id="out"></pre>
    `,
  }).mount('#app');
</script>

Lattice Grid Buy a licence

demo D180

Profiling a column

Count, spread, quartiles and outliers from the API, into a panel of your own

grid.statistics.profile(col)

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'symbol', title: 'Symbol', layout: { pin: 'start', width: 120 } },
    { field: 'desk', title: 'Desk', filter: { type: 'set' } },
    { field: 'price', title: 'Price', type: 'number' },
    { field: 'bid', title: 'Bid', type: 'number' },
    { field: 'volume', title: 'Volume', type: 'number' },
    { field: 'notional', title: 'Notional', type: 'number',
      format: { style: 'currency', currency: 'USD' }, total: 'sum' },
  ];

  const rows = [/* trade records */];

  function App() {
    const gridRef = React.useRef(null);
    const [out, setOut] = React.useState('');

    // profile() reads a full summary of one column over the filtered rows, so
    // every figure follows the filters.
    const report = () => {
      const grid = gridRef.current && gridRef.current.grid;
      if (grid) setOut(JSON.stringify(grid.statistics.profile('notional'), null, 2));
    };

    React.useEffect(report, []);

    return (
      <>
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          toolPanel={{ side: 'left', panels: ['filters', 'columns'] }}
          columns={columns}
          rows={rows}
          onFilterChanged={report}
          style={{ height: '460px' }}
        />
        <pre style={{ marginTop: '12px' }}>{out}</pre>
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D180

Profiling a column

Count, spread, quartiles and outliers from the API, into a panel of your own

grid.statistics.profile(col)

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'symbol', title: 'Symbol', layout: { pin: 'start', width: 120 } },
  { field: 'desk', title: 'Desk', filter: { type: 'set' } },
  { field: 'price', title: 'Price', type: 'number' },
  { field: 'bid', title: 'Bid', type: 'number' },
  { field: 'volume', title: 'Volume', type: 'number' },
  { field: 'notional', title: 'Notional', type: 'number',
    format: { style: 'currency', currency: 'USD' }, total: 'sum' },
];

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<lattice-grid [config]="grid" (filter-changed)="report()" style="display:block;height:460px"></lattice-grid>' +
    '<pre style="margin-top:12px">{{ out }}</pre>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;
  out = '';

  grid = {
    rowKey: 'id',
    toolPanel: { side: 'left', panels: ['filters', 'columns'] },
    columns,
    rows: [/* trade records */],
  };

  // profile() reads a full summary of one column over the filtered rows, so every
  // figure follows the filters.
  report() {
    const grid = this.gridRef && this.gridRef.grid;
    if (grid) this.out = JSON.stringify(grid.statistics.profile('notional'), null, 2);
  }

  ngAfterViewInit() { this.report(); }
}

bootstrapApplication(AppComponent);